﻿// Keep this lines for a best effort IntelliSense of Visual Studio 2017.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.d.ts" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Controls\System\TcHmiControl\Source.d.ts" />

// Keep this lines for a best effort IntelliSense of Visual Studio 2013/2015.
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\Lib\jquery\jquery.js" />
/// <reference path="C:\TwinCAT\Functions\TE2000-HMI-Engineering\Infrastructure\TcHmiFramework\Latest\TcHmi.js" />

(function (TcHmi) {

    

    var EnumLabel = function (ctx,EnumSymbol) {

       EnumName = EnumSymbol.getExpression().getName()

        var request = {
            'requestType': 'ReadWrite',
            'commands': [
                {
                    'symbol': EnumName
                },
                {
                    'commandOptions' : ["SendWriteValue"],
                    'symbol': 'GetSchema',
                    'writeValue': {'symbol':EnumName}
                }
            ]
        };

        TcHmi.Server.request(request, function (data) {
            // Callback handling.
            if (data.error !== TcHmi.Errors.NONE) {
                // Handle TcHmi.Server class level error here.
                return;
            }
            var response = data.response;
            if (response.error !== undefined) {
                // Handle TwinCAT HMI Server response level error here.
                return;
            }
            var commands = response.commands;
            if (commands === undefined) {
                return;
            }
            for (var i = 0, ii = commands.length; i < ii; i++) {
                var command = response.commands[i];
                if (command === undefined) {
                    return;
                }
                if (command.error !== undefined) {
                    // Handle TwinCAT HMI Server command level error here.
                    return;
                }
                // Handle result...

                var EnumValue;
                var EnumSchema;

                if (command.symbol == EnumName) { EnumValue = command.readValue }
                if (command.symbol == "GetSchema") { EnumSchema = command.readValue }

            }

            let EnumLabels = EnumSchema.options  // the return value of GetSchema for an enum stores labels in '.options'

            // Iterates through the list of options only looking for the object that matches the .indexOf(EnumValue)
            let EnumLabel = EnumLabels[EnumLabels.map(function (item) { return item.value; }).indexOf(EnumValue)].label;

            // ctx.success acts as the final return value of this TcHmi function set to Wait Mode
            ctx.success(EnumLabel);

        });




    };
    
    TcHmi.Functions.registerFunction('EnumLabel', EnumLabel);
})(TcHmi);